e
_ Program to list lazy greenius assembler programs

_ Define a start location

	org $1350

_ define the storage locations used

loadaddr 	= $2000
bsout	= $ffd2
po	= $fa
lo        = $fc
en	res 2
ct	res 2
cb	res 2 
savepo	res 2

_ Code start
_ input is A=filename length
_          X=filename address low
_          Y=filename address high
_ bank will have been set before this program was called

	 $ffbd		_ set name
	 #0
	 #0
	 $ff68		_ set bank
	 #0
	 #8
	 #0
	 $ffba		_ set lfs
	 #0
	 #>loadaddr
	 #<loadaddr
	 $ffd5		_ load 
	 error
	 en
	 en+1
	 display
error				_ return error in A

_
_ Now we display the screen
_
display	equ *
	 #147
	 bsout
	 #1
	 #>loadaddr
	 po
	 ct
	 #<loadaddr
	 po+1
	 ct+1
	 #0
dispscr	equ *
	 [po],y
	 #13
	 nocheck
	
	 #26
	 exitline
nocheck	equ *
	 outchar
	 po
	 noinc9
	 po+1
noinc9	equ *
	 po+1		_ assume that there is at least one character
	 en+1		_ in the file and that en is the position 
	 dispscr		_ after this character so po could equal en
	 po		_ at some point if we reach the end before
	 en		_ before the end of the screen
	 dispscr
exitline	equ *		_ end of file or last CR would mean 26th line          
	 po
	
	 #1
	 cb
	 po+1
	 #0
	 cb+1
_
_ control the input
_
loopkey	equ *
	 #3
loopdel1	equ *
	 #0
loopdel2	equ *
	
	 loopdel2
	
	 loopdel1
	 $d4
	 #83
	 scrdown
	 #84
	 scrup
	 #7
	 shift
	 #41
	 prt
	 #57
	 loopkey
	 #0
	
shift	 $d3
	 scrup
	 #1
	 scrdown
	 loopkey
prt	 print
scrup	equ *
	 cb+1		_ if cb < en then scroll up
	 en+1
	 extra3
	 loopkey
	 scrollup
extra3	 cb
	 en
	 loopkey
	 scrollup
_
_ do the scroll down logic
_ 
scrdown	equ *		_ if ct > loadaddr then continue
	 ct+1
	 #<loadaddr
	 loopkey		_ if ct(high) < loadaddr then ct < loadaddr
	 possible		_ if ct(high) = loadaddr then possible
	 dodown		_ definite
possible  equ *
	 #>loadaddr
	 ct
	 loopkey
dodown	equ *
	 #27
	 bsout
	 #87
	 bsout		_ scroll the screen down
	 #19		_ home the cursor
	 bsout
_
_ start of the logic to scan for the previous line
_
	 ct
	
	 #2
	 po
	 savepo
	 ct+1
	 #0
	 po+1		_ po=ct-2 point past last cr
	 savepo+1		_ save ct-2
	 #0
loopup1	equ *		_ locate the start of the line
	 [po],y
	 #13		_ have we found a CR
	 fndup1		_ yes so stop
	 po		_ po=po-1
	 po
	 #$ff
	 nodec1
	 po+1
nodec1	equ *
	 po+1		_ if po <= loadaddr then stop 
	 #<loadaddr	
	 setstart
	 extra1
	 loopup1
extra1	equ *
	 po
	 #>loadaddr
	 loopup1
setstart  equ *
	 #>loadaddr
	 po
	 #<loadaddr
	 po+1
	 noinc1

fndup1	equ *		_ found either the CR or start of text
	 po		_ point to next char if CR found
	 noinc1		_ if start of text then we would have gone
	 po+1		_ gone past the start by 1 so increment
_
_ if po > ct-2 then all we found was a carriage return on the  last line
_ so don't display anything
_
noinc1	equ *
	 po
	 ct
	 po+1
	 ct+1		_ this will be the new current top
	 savepo+1
	 po+1
	 leave1
	 extra2
	 disp
extra2	equ *
	 savepo
	 po
	 leave1
disp 	equ *
	 [po],y
	 outchar
	 po
	 savepo
	 incpo
	 po+1
	 savepo+1
	 leave1
incpo	equ *
	 po
	 disp
	 po+1
	 disp
_
_ displayed the line if >40 then we would have had to scroll down twice
_
leave1	equ *
_
_ This logic just looks for the current bottom start of line
_
	 cb
	
	 #2
	 po
	 cb+1
	 #0
	 po+1		_ po=ct-2 point past last cr
	 #0
loopup2	equ *		_ locate the start of the line
	 [po],y
	 #13
	 fndup2
	 po
	 po
	 #$ff
	 loopup2
	 po+1
	 loopup2
fndup2	equ *
	 po
	 noinc2
	 po+1
noinc2	equ *
	 po
	 cb
	 po+1
	 cb+1
	 loopkey

_
_ here is the logic to scroll up.
_
scrollup	equ *
	 #27
	 bsout
	 #86
	 bsout		_ scroll up
	 #19
	 bsout		_ home cursor
	 #24		_ 24 cursor downs
	 #17
loopcur	equ *
	 bsout
	
	 loopcur
_
_ here we go...
_ 
	 cb
	 po
	 cb+1
	 po+1
	 #0
loopit	equ *
	 [po],y
	 #13
	 leave4
	 outchar
	 po
	 check2
	 po+1
check2	equ *
	 po+1
	 en+1
	 loopit
	 extra4
	 leave4
extra4	equ *
	 po
	 en
	 loopit
leave4	equ *
	 po
	 noinc4
	 po+1
noinc4	equ *
	 po
	 cb
	 po+1
	 cb+1
_
_ line now displayed so lets locate the current top
_
	 ct
	 po
	 ct+1
	 po+1
loop5	equ *
	 [po],y
	 po
	 forward
	 po+1
forward	equ *
	 #13
	 loop5
	 po
	 ct
	 po+1
	 ct+1
	 loopkey
_
_ Now output characters and convert the tokens
_
outchar	equ *
	 savex
	 savey
	 #128
	 convert
	 bsout
exitchar	equ *
	 savex
	 savey
	
convert	equ *
	
	 #128
	
	 #>table
	 lo
	 #<table
	 lo+1
	 #0
	 outit
loop9	equ *
	 lo
	
	 #3
	 lo
	 lo+1
	 #0
	 lo+1
	
	 loop9
outit	equ *
	 #0
loop8	equ *
	 [lo],y
	 bsout
	 exitchar
	
	 #3
	 loop8
          		_ set a good return code
	 exitchar
table 	equ *
	db  "adcandaslbccbcsbeqbitbmibnebplbrkbvcbvsclccldcliclvcmpcpxcpy"
	db  "decdexdeyeorincinxinyjmpjsrldaldxldylsrnoporaphaphpplaplprol"
	db  "rorrtirtssbcsecsedseistastxstytaxtaytsxtxatxstya"
savex	res 1
savey	res 1

_
_ routine to print from loadaddr to en
_
print	equ *
	 #0		_ set length to zero
	 $ffbd
	 #1
	 #4
	 #7
	 $ffba		_ set LFS
	 $ffc0		_ open the file
	 prtcont1
prterror1	equ *
	 loopkey
prtcont1	equ *
	 #1
	 $ffc9		_ BSOUT routed the logical file number def
	 prtcont2
prterror2 equ *
	 #1
	 $ffc3		_ close the LA
	 prterror1
prtcont2  equ *
	 #>loadaddr
	 po
	 #<loadaddr
	 po+1
	 #0
loopprt	equ *
	 po
	 en
	 incloop
	 po+1
	 en+1
	 prtfin
incloop   equ *
	 [po],y
	 outchar
	 prtfin
	 $d4
	 #13		_ s key pressed ?
	 prtfin
	 po
	 loopprt
	 po+1
	 loopprt
prtfin	equ *
	 $ffcc		_ reset the channels
	 prterror2		_ reset bsout and close the file and exit	


o